<template>
  <div id="payment-modal">
    <div class="modal">
      <div class="modal-header">
        <label>Thông tin thanh toán</label>
        <button class="close-btn" @click="closeModal">X</button>
      </div>
      <div class="modal-body">
        <table>
          <tbody>
            <tr>
              <td><label>Đóng góp cho hoạt động:</label></td>
              <td><label><strong>{{ detail.activity.name }}</strong> </label></td>
            </tr>
            <tr>
              <td><label>Người đóng góp: </label></td>
              <td><label>{{ user.first_name }} {{ user.last_name }}</label></td>
            </tr>
            <tr>
              <td><label>Số tiền: </label></td>
              <td><label>{{ detail.amount.toLocaleString() }} VNĐ</label></td>
            </tr>
            <tr>
              <td><label>Lời nhắn: </label></td>
              <td><label>{{ detail.message }}</label></td>
            </tr>
            <tr>
              <td><label>Phương thức thanh toán: </label></td>
              <td><label>{{ detail.methods }}</label></td>
            </tr>
          </tbody>
        </table>

      </div>
      <div class="modal-footer">
        <button v-if="!process" class="confirm-btn" @click="processPayment">Xác Nhận</button>
        <button v-else class="confirm-btn disable" @click="processPayment">Xác Nhận</button>
      </div>
    </div>
  </div>
</template>

<script>
import PaymentServices from '@/services/PaymentServices'

export default {
  name: "PaymentModal",
  props: {
    detail: Object
  },
  data() {
    return {
      process: false,
      user: this.$store.getters.getUser,
    }
  },
  methods: {
    closeModal() {
      this.$emit('close')
    },
    async processPayment() {
      if(this.process) return
      this.process = true

      try {
        let donationuser = null
        let response = await PaymentServices.postDonations({
          donationId: this.$route.params.id,
          donation: this.detail.amount,
          username: this.user.username,
          message: this.detail.message,
          date: Date.now(),
        })
        console.log(response)
        if (response.status == 200) {
          donationuser = response.data
        }

        if (!donationuser) throw ('Failed to donate')
        let payment_res = await PaymentServices.postPayment({
          typeOfCard: this.detail.methods,
          donationUserId: donationuser.id,
          success: true
        })
        console.log(payment_res)
        if (payment_res.status == 200) {
          alert("PAYMENT SUCCESS")
          this.$router.push({ name: 'Donation', params: { id: this.$route.params.id } })
        }
        else {
          alert(response.statusText)
        }
      }
      catch (err) {
        console.log(err)
        alert('Payment Fail')
      }
      finally {
        this.$emit('close')
        this.process = false
      }
    }
  }
}
</script>

<style scoped>
#payment-modal {
  position: fixed;
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  z-index: 99;
  background-color: rgb(0, 0, 0, 0.4);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  width: 720px;
  background-color: #FFF;
  border-radius: 10px;
  padding: 20px;
  display: flex;
  flex-direction: column;
}

.modal-header {
  margin-bottom: 10px;
  display: flex;
  justify-content: space-between;
}

.modal-header>label {
  font-weight: bold;
}

.close-btn {
  border-radius: 50%;
  width: 24px;
  height: 24px;
  align-items: center;
}

.close-btn:hover {
  cursor: pointer;
}

.modal-body {
  margin: 10px 0px;
  flex-direction: column;
  font-size: 16px;
}

table {

  width: 100%;
  table-layout: auto;
}

table td {
  padding: 10px;
}


.modal-footer {
  display: flex;
  justify-content: center;
}

.confirm-btn {
  padding: 10px 20px;
  border: none;
  background-color: #2196F3;
  font-weight: bold;
  color: white;
  border-radius: 6px;
  border-width: 2px;
}

.disable{  
  background-color: #81bff3;
  color: white;
}

.confirm-btn:hover {
  cursor: pointer;
  background-color: #197bcb;
}
</style>